import type { ExtendSimulationSchemaInput } from "./schema";
import { setupStore } from "./setup";
import type { AnyState, StoreUpdater } from "starfx";
import { createThunks } from "starfx";
type StoreThunks = ReturnType<typeof createThunks>;
type Store<ExtendedSimulationSchema> = ReturnType<typeof setupStore<ExtendedSimulationSchema>>;
export type ExtendSimulationActionsInput<Actions, ExtendedSimulationSchema> = (arg: {
    thunks: StoreThunks;
    store: Store<ExtendedSimulationSchema>["store"];
    schema: Store<ExtendedSimulationSchema>["schema"];
}) => Actions;
export declare function createSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>({ actions: inputActions, schema: inputSchema, }?: {
    schema: ExtendSimulationSchemaInput<ExtendedSimulationSchema>;
    actions: ExtendSimulationActionsInput<ExtendedSimulationActions, ExtendedSimulationSchema>;
}): {
    store: import("starfx").FxStore<{
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema extends infer T extends import("starfx").FxMap ? { [key in keyof T]: ReturnType<({
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema)[key]>["initialState"]; } : never>;
    schema: import("starfx").FxSchema<{
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema extends infer T_1 extends import("starfx").FxMap ? { [key in keyof T_1]: ReturnType<({
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema)[key]>["initialState"]; } : never, {
        cache: (n: string) => import("starfx").TableOutput<{}, AnyState, {}>;
        loaders: (name: string) => import("starfx").LoaderOutput<M, AnyState>;
    } & ExtendedSimulationSchema>;
    actions: {
        batchUpdater: import("starfx").CreateActionWithPayload<Omit<import("starfx").ThunkCtx<any>, "payload"> & import("starfx").Payload<StoreUpdater<AnyState>[]>, StoreUpdater<AnyState>[], any>;
    } & ExtendedSimulationActions;
};
type CreateSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions> = typeof createSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>;
export type SimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions> = ReturnType<CreateSimulationStore<ExtendedSimulationSchema, ExtendedSimulationActions>>;
export type ExtendSimuationActions<InputSchema extends ExtendSimulationSchemaInput<any>> = {
    thunks: StoreThunks;
    store: Store<ReturnType<InputSchema>>["store"];
    schema: Store<ReturnType<InputSchema>>["schema"];
};
export {};
//# sourceMappingURL=index.d.ts.map